Index: /trunk/web2/addons/job_monarch/js/jobgrid.js
===================================================================
--- /trunk/web2/addons/job_monarch/js/jobgrid.js	(revision 546)
+++ /trunk/web2/addons/job_monarch/js/jobgrid.js	(revision 547)
@@ -8,4 +8,9 @@
 
 var filterfields = [ "jid", "queue", "name", "owner" ];
+
+function ClusterImageSelectHost( somehost )
+{
+ // reload clusterimage with somehost as arg
+}
 
 function isset( somevar )
@@ -276,4 +281,5 @@
       loadMask: true,
       selModel: new Ext.grid.RowSelectionModel({singleSelect:false}),
+      stripeRows: true,
       bbar: new Ext.PagingToolbar({
                 pageSize: 30,
@@ -291,4 +297,20 @@
     });
 
+  ClusterImageWindow = new Ext.Window({
+      id: 'ClusterImageWindow',
+      title: 'Cluster Nodes Overview',
+      closable:true,
+      collapsible: true,
+      animCollapse: true,
+      width:100,
+      height:100,
+      y: 50,
+      plain:true,
+      shadow: true,
+      resizable: false,
+      shadowOffset: 10,
+      layout: 'fit'
+    });
+
   JobListingWindow = new Ext.Window({
       id: 'JobListingWindow',
@@ -298,4 +320,5 @@
       animCollapse: true,
       maximizable: true,
+      y: 400,
       width:900,
       height:500,
Index: /trunk/web2/addons/job_monarch/libtoga.php
===================================================================
--- /trunk/web2/addons/job_monarch/libtoga.php	(revision 546)
+++ /trunk/web2/addons/job_monarch/libtoga.php	(revision 547)
@@ -1146,4 +1146,5 @@
 
 		$area_tooltip		= $this->hostname;
+		$area_onclick		= "return ClusterImageSelectHost( \"" . $this->hostname . "\" )";
 
 		if( $this->down)
@@ -1158,4 +1159,5 @@
 		$area_tooltip		= $area_tooltip . ": " . implode( " ", $this->jobs );
 
+		$tag_onclick		= "ONCLICK=\"" . $area_onclick . "\"";
 		$tag_href		= "HREF=\"" . $area_href . "\"";
 		$tag_coords		= "COORDS=\"" . $area_coords . "\"";
@@ -1163,5 +1165,5 @@
 		$tag_tooltip2		= "TITLE=\"" . $area_tooltip . "\"";
 
-		return ("<AREA SHAPE=\"RECT\" " . $tag_coords . " " . $tag_href . " " . $tag_tooltip1 . " " . $tag_tooltip2 . ">");
+		return ("<AREA SHAPE=\"RECT\" " . $tag_coords . " " . $tag_onclick . " " . $tag_href . " " . $tag_tooltip1 . " " . $tag_tooltip2 . ">");
 	}
 
Index: /trunk/web2/addons/job_monarch/overview.php
===================================================================
--- /trunk/web2/addons/job_monarch/overview.php	(revision 546)
+++ /trunk/web2/addons/job_monarch/overview.php	(revision 547)
@@ -78,6 +78,6 @@
 	$tpl->assign( "clusterimage", "./image.php?". session_name() . "=" . session_id() ."&c=".rawurlencode($clustername)."&view=big-clusterimage".$filter_image_url );
 
-	//$tpl->assign( "clusterimage_width", $ic->getWidth() );
-	//$tpl->assign( "clusterimage_height", $ic->getHeight() );
+	$tpl->assign( "clusterimage_width", $ic->getWidth() );
+	$tpl->assign( "clusterimage_height", $ic->getHeight() );
 
 	$tpl->newBlock( "node_clustermap" );
Index: /trunk/web2/addons/job_monarch/templates/header.tpl
===================================================================
--- /trunk/web2/addons/job_monarch/templates/header.tpl	(revision 546)
+++ /trunk/web2/addons/job_monarch/templates/header.tpl	(revision 547)
@@ -23,4 +23,8 @@
 	params = newparams;
     });
+  ClusterImageWindow.html = '<IMG SRC="{clusterimage}" USEMAP="#MONARCH_CLUSTER_BIG" BORDER="0">';
+  ClusterImageWindow.height = '{clusterimage_height}';
+  ClusterImageWindow.width = '{clusterimage_width}';
+  ClusterImageWindow.show();
   JobsDataStore.load( {params: {start: 0, limit: 30}} );
   JobListingWindow.setTitle( "{cluster} Jobs Overview" );
@@ -32,4 +36,10 @@
 <BODY BGCOLOR="#FFFFFF">
 
+    <MAP NAME="MONARCH_CLUSTER_BIG">
+    <!-- START BLOCK : node_clustermap -->
+    {node_area_map}
+    <!-- END BLOCK : node_clustermap -->
+    </MAP> 
+
   <A HREF="https://subtrac.sara.nl/oss/jobmonarch/">
   <IMG SRC="./jobmonarch.gif" ALT="Job Monarch" BORDER="0"></IMG>
Index: /trunk/web2/addons/job_monarch/templates/overview.tpl
===================================================================
--- /trunk/web2/addons/job_monarch/templates/overview.tpl	(revision 546)
+++ /trunk/web2/addons/job_monarch/templates/overview.tpl	(revision 547)
@@ -131,11 +131,4 @@
 
   <TD ALIGN="CENTER"><CENTER>
-<!-- INCLUDESCRIPT BLOCK : ci_script -->
-    <IMG SRC="{clusterimage}" USEMAP="#MONARCH_CLUSTER_BIG" BORDER="0">
-    <MAP NAME="MONARCH_CLUSTER_BIG">
-<!-- START BLOCK : node_clustermap -->
-{node_area_map}
-<!-- END BLOCK : node_clustermap -->
-    </MAP>
     <BR>
 <FONT class="footer">Last updated: {report_time}</FONT></CENTER>