Index: /trunk/web2/addons/job_monarch/css/styles.css
===================================================================
--- /trunk/web2/addons/job_monarch/css/styles.css	(revision 553)
+++ /trunk/web2/addons/job_monarch/css/styles.css	(revision 554)
@@ -3,4 +3,9 @@
    color: blue;
    cursor: pointer;
+}
+
+.monarch
+{
+   background: none;
 }
 
@@ -11,12 +16,2 @@
    cursor: pointer;
 }
-
-.even
-{
-   background: rgb(255,255,255);
-}
-
-.odd
-{
-   background: rgb(240,240,240);
-}
Index: /trunk/web2/addons/job_monarch/js/jobgrid.js
===================================================================
--- /trunk/web2/addons/job_monarch/js/jobgrid.js	(revision 553)
+++ /trunk/web2/addons/job_monarch/js/jobgrid.js	(revision 554)
@@ -397,12 +397,12 @@
   ClusterImageWindow = new Ext.Window({
       id: 'ClusterImageWindow',
-      title: 'Cluster Nodes Overview',
-      closable:true,
+      title: 'Nodes',
+      closable: true,
       collapsible: true,
       animCollapse: true,
-      width:100,
-      height:100,
+      width: 100,
+      height: 100,
       y: 15,
-      plain:true,
+      plain: true,
       shadow: true,
       resizable: false,
@@ -415,4 +415,43 @@
         })
 
+    });
+
+  GraphSummaryWindow = new Ext.Window({
+      id: 'GraphSummaryWindow',
+      title: 'Graph Summary',
+      closable: true,
+      collapsible: true,
+      animCollapse: true,
+      width: 300,
+      height: 500,
+      y: 15,
+      plain: true,
+      shadow: true,
+      resizable: true,
+      shadowOffset: 10,
+      layout: 'table',
+      layoutConfig: {
+		columns: 2
+	},
+      defaults:{border: false},
+      items: [{
+	id: 'monarchlogo',
+	cls: 'monarch',
+	bodyStyle: 'background: transparent',
+	html: '<A HREF="https://subtrac.sara.nl/oss/jobmonarch/" TARGET="_blank"><IMG SRC="./jobmonarch.gif" ALT="Job Monarch" BORDER="0"></A>'
+        //colspan: 2
+       },{
+	id: 'summarycount'
+       },{
+	id: 'rjqjgraph'
+       },{
+	id: 'pie',
+	colspan: 2
+       }],
+      bbar: new Ext.StatusBar({
+            	defaultText: 'Ready.',
+            	id: 'basic-statusbar',
+            	defaultIconCls: ''
+        })
     });
 
Index: /trunk/web2/addons/job_monarch/overview.php
===================================================================
--- /trunk/web2/addons/job_monarch/overview.php	(revision 553)
+++ /trunk/web2/addons/job_monarch/overview.php	(revision 554)
@@ -596,7 +596,8 @@
 	{
 
-		$rjqj_str  = "<A HREF=\"./graph.php?z=large&c=$clustername&g=job_report&r=$range&st=$cluster[LOCALTIME]\">";
-		$rjqj_str .= "<IMG BORDER=0 SRC=\"./graph.php?z=small&c=$clustername&g=job_report&r=$range&st=$cluster[LOCALTIME]\">";
-		$rjqj_str .= "</A>";
+		//$rjqj_str  = "<A HREF=\"./graph.php?z=large&c=$clustername&g=job_report&r=$range&st=$cluster[LOCALTIME]\">";
+		//$rjqj_str .= "<IMG BORDER=0 SRC=\"./graph.php?z=small&c=$clustername&g=job_report&r=$range&st=$cluster[LOCALTIME]\">";
+		$rjqj_str .= "./graph.php?z=small&c=$clustername&g=job_report&r=$range&st=$cluster[LOCALTIME]";
+		//$rjqj_str .= "</A>";
 
 		$tpl->gotoBlock( "_ROOT" );
Index: /trunk/web2/addons/job_monarch/templates/header.tpl
===================================================================
--- /trunk/web2/addons/job_monarch/templates/header.tpl	(revision 553)
+++ /trunk/web2/addons/job_monarch/templates/header.tpl	(revision 554)
@@ -39,5 +39,10 @@
   JobListingWindow.show();
   reloadJobStore();
-  });
+
+  GraphSummaryWindow.show();
+
+  Ext.get( 'rjqjgraph' ).update( '<IMG ID="rjqj_graph" SRC="{rjqj_graph}" BORDER=0>' );
+  Ext.get( 'pie' ).update( '<IMG ID="pie" SRC="{pie}" BORDER=0>' );
+});
 </script>
 
@@ -50,6 +55,2 @@
     <!-- END BLOCK : node_clustermap -->
     </MAP> 
-
-  <A HREF="https://subtrac.sara.nl/oss/jobmonarch/">
-  <IMG SRC="./jobmonarch.gif" ALT="Job Monarch" BORDER="0"></IMG>
-  </A>
Index: /trunk/web2/addons/job_monarch/templates/overview.tpl
===================================================================
--- /trunk/web2/addons/job_monarch/templates/overview.tpl	(revision 553)
+++ /trunk/web2/addons/job_monarch/templates/overview.tpl	(revision 554)
@@ -1,6 +1,2 @@
-<P>
-All tasks of parallel and array jobs appear as a single &lsquo;job&rsquo;.
-<BR></P>
-
 </FORM>
 
@@ -128,6 +124,4 @@
 
 <BR>
-{rjqj_graph}
-
   <TD ALIGN="CENTER"><CENTER>
     <BR>
@@ -137,5 +131,4 @@
   </TD>
   <TD ALIGN="CENTER">
-    <IMG SRC="{pie}">
   </TD>
 </TR>